<?php

class SPM_ShopyMind_Action_SyncCarriers implements SPM_ShopyMind_Interface_Action
{
    private $params;

    public function __construct(SPM_ShopyMind_Model_Scope $scope, $start, $limit, $lastUpdate, $carrierId, $justCount)
    {
        $this->params['start'] = $start;
        $this->params['limit'] = $limit;
        $this->params['lastUpdate'] = $lastUpdate;
        $this->params['carrierId'] = $carrierId;
        $this->params['justCount'] = $justCount;
        $this->params['scope'] = $scope;
    }

    public function process()
    {

        $carriers = $this->retrieveCarriers();
        if ($this->params['justCount']) {
            return $carriers;
        }


        return $carriers;
    }

    public function retrieveCarriers()
    {
        $carriersData = array();

        if($this->params['start'] == 0 || $this->params['justCount']) {
            $carriers = Mage::getsingleton("shipping/config")->getAllCarriers();
            foreach ($carriers as $code => $method) {
                $carriersData[] = array(
                    'id_carrier' => $code,
                    "name" => Mage::getStoreConfig("carriers/$code/title"),
                    'active' => 1
                );
            }
        }

        if ($this->params['justCount']) {
            return count($carriersData);
        }
        return $carriersData;
    }
}
