<?php

class SPM_ShopyMind_Action_SyncCustomersGroups implements SPM_ShopyMind_Interface_Action
{
    private $params;

    public function __construct(SPM_ShopyMind_Model_Scope $scope, $start, $limit, $lastUpdate, $groupId, $justCount)
    {
        $this->params['start'] = $start;
        $this->params['limit'] = $limit;
        $this->params['lastUpdate'] = $lastUpdate;
        $this->params['groupId'] = $groupId;
        $this->params['justCount'] = $justCount;
        $this->params['scope'] = $scope;
    }

    public function process()
    {
        $storeIds = $this->params['scope']->storeIds();
        $return = array();
        /** @var  $appEmulation Mage_Core_Model_App_Emulation */
        $appEmulation = Mage::getSingleton('core/app_emulation');
        foreach ($storeIds AS $storeId) {
            $initialScope = $this->params['scope'];
            $scope = SPM_ShopyMind_Model_Scope::fromShopymindId('store-'.$storeId);
            //echo $scope->getLang();
            $this->params['scope'] = $scope;

            $emulatedEnvironment = $appEmulation->startEnvironmentEmulation($storeId);

            $customerGroups = $this->retrieveCustomerGroups($storeId);

            foreach ($customerGroups as $customerGroup) {
                $customerGroup_key = $customerGroup['id_group'].'-'.$customerGroup['lang'];
                if(!isset($return[$customerGroup_key])) $return[$customerGroup_key] = $customerGroup;
            }

            $appEmulation->stopEnvironmentEmulation($emulatedEnvironment);
            $this->params['scope'] = $initialScope;
        }
        if ($this->params['justCount']) {
            return count($return);
        }
        return $return;

    }

    public function retrieveCustomerGroups($storeId)
    {
        $customerGroupCollection = Mage::getModel('customer/group')->getCollection();
            //->addFieldToFilter('updated_at', array('gteq' => $this->params['lastUpdate']))

        $customerGroupCollection->setOrder('customer_group_id','ASC');
        

        if ($this->params['groupId']) {
            $customerGroupCollection->addFieldToFilter('customer_group_id', array('in' => $this->params['groupId']));
        }

        if ($this->params['limit']) {
            $customerGroupCollection->getSelect()->limit($this->params['limit'], $this->params['start']);
        }

        return array_map(function($group) {
            return array(
                'id_group' => $group->getCustomerGroupId(),
                'id_shop'   => $this->params['scope']->shopyMindId(),
                'name' => $group->getCustomerGroupCode(),
                'lang' => $this->params['scope']->getLang(),
                'date_creation' => '2019-01-01 00:00:00',
                'date_update' => date('Y-m-d H:i:s'),
        );
        }, iterator_to_array($customerGroupCollection->getIterator()));
    }
}
