<?php

class SPM_ShopyMind_Action_SyncManufacturers implements SPM_ShopyMind_Interface_Action
{
    private $params;

    public function __construct(SPM_ShopyMind_Model_Scope $scope, $start, $limit, $lastUpdate, $manufacturerId, $justCount)
    {
        $this->params['start'] = $start;
        $this->params['limit'] = $limit;
        $this->params['lastUpdate'] = $lastUpdate;
        $this->params['manufacturerId'] = $manufacturerId;
        $this->params['justCount'] = $justCount;
        $this->params['scope'] = $scope;
    }

    public function process()
    {

        $manufacturers = $this->retrieveManufacturers();
        if ($this->params['justCount']) {
            return $manufacturers;
        }


        return $manufacturers;
    }

    public function retrieveManufacturers()
    {
        $attribute = Mage::getModel('eav/config')->getAttribute('catalog_product', SPM_ShopyMind_Helper_Data::MANUFACTURER_ATTRIBUTE_CODE);

        if ($this->params['scope']->getId()) {
            $this->params['scope']->restrictEavAttribute($attribute);
        }
        $collectionManufacturers = Mage::getResourceModel('eav/entity_attribute_option_collection')
            ->setAttributeFilter($attribute->getData('attribute_id'))
            ->setStoreFilter(0, false);

        if ($this->params['justCount']) {
            return $collectionManufacturers->count();
        }

        $return = array();
        if($this->params['start'] == 0 ) {
            foreach ($collectionManufacturers as $value) {
                if (!$this->params['manufacturerId'] || $this->params['manufacturerId'] == $value->getOptionId()) {
                    $return[] = array(
                        'id_manufacturer' => $value->getOptionId(),
                        'name' => $value->getValue(),
                        'active' => 1
                    );
                }
            }
        }

        return $return;

    }
}
