<?php

class SPM_ShopyMind_Action_SyncOrdersStatus implements SPM_ShopyMind_Interface_Action
{
    private $params;

    public function __construct(SPM_ShopyMind_Model_Scope $scope, $start, $limit, $lastUpdate, $orderStatusId, $justCount)
    {
        $this->params['start'] = $start;
        $this->params['limit'] = $limit;
        $this->params['lastUpdate'] = $lastUpdate;
        $this->params['orderStatusId'] = $orderStatusId;
        $this->params['justCount'] = $justCount;
        $this->params['scope'] = $scope;
    }

    public function process()
    {

        $storeIds = $this->params['scope']->storeIds();
        $return = array();
        /** @var  $appEmulation Mage_Core_Model_App_Emulation */
        $appEmulation = Mage::getSingleton('core/app_emulation');
        foreach ($storeIds AS $storeId) {
            $initialScope = $this->params['scope'];
            $scope = SPM_ShopyMind_Model_Scope::fromShopymindId('store-'.$storeId);
            //echo $scope->getLang();
            $this->params['scope'] = $scope;

            $emulatedEnvironment = $appEmulation->startEnvironmentEmulation($storeId);

            $ordersStatus = $this->retrieveOrdersStatus($storeId);

            foreach ($ordersStatus as $orderStatus) {
                $orderStatus_key = $orderStatus['id_status'].'-'.$orderStatus['lang'];
                if(!isset($return[$orderStatus_key])) $return[$orderStatus_key] = $orderStatus;
            }

            $appEmulation->stopEnvironmentEmulation($emulatedEnvironment);
            $this->params['scope'] = $initialScope;
        }
        if ($this->params['justCount']) {
            return count($return);
        }
        return $return;
    }

    public function retrieveOrdersStatus($storeId)
    {
        $return = array ();
        $mageVersion = Mage::getVersion();
        if (version_compare ($mageVersion, '1.5', '>')) {
            $results = Mage::getModel('sales/order_status')->getCollection();
            if ($this->params['orderStatusId']) {
                $results->addFieldToFilter('status', array('in' => $this->params['orderStatusId']));
            }

            if ($this->params['limit']) {
                $results->getSelect()->limit($this->params['limit'], $this->params['start']);
            }



            $results = $results->getData();
            //Récupération des labels par store
            if($storeId) {
                $tablePrefix = Mage::getConfig()->getTablePrefix();
                $resource = Mage::getSingleton('core/resource');

                $readConnection = $resource->getConnection('core_read');
                foreach ($results as &$row) {
                    $query = 'SELECT `label`
                 FROM `' . $tablePrefix . 'sales_order_status_label`
                WHERE `status` = "'.$row['status'].'" AND  `store_id` = '.(int)$storeId.'
                LIMIT 1';
                    $label = $readConnection->fetchCol($query);
                    if(count($label)) $row['label'] = $label[0];
                }
            }
        } else {
            $tablePrefix = Mage::getConfig()->getTablePrefix();
            $resource = Mage::getSingleton('core/resource');

            $readConnection = $resource->getConnection('core_read');
            $query = 'SELECT `value` as `status`, `value` as `label`
	         FROM `' . $tablePrefix . 'sales_order_entity_varchar`
	        WHERE `attribute_id` = ' . self::getMagentoAttributeCode('order_status_history', 'status') . '
	        GROUP BY `value`';
            $results = $readConnection->fetchAll($query);
        }
        if ($results && is_array($results) && sizeof($results)) {
            foreach ( $results as $row ) {
                $return [] = array(
                    'id_status' =>$row['status'],
                    'name' => $row['label'],
                    'lang' => $this->params['scope']->getLang(),
                    'deleted' => 0
                );
            }
        }
        return $return;
    }
}
