<?php

class SPM_ShopyMind_Block_Adminhtml_System_Config_Form_Field_Mapfields extends Mage_Adminhtml_Block_System_Config_Form_Field_Array_Abstract
{
    protected $_tableFields = array();
    protected $_shopimindFields = array();

    public function __construct()
    {
        $helper = $this->makeHelper();

        // Get current selected table
        $scope = $helper->getCurrentScope();
        $table = $helper->getConfigValueForScope('shopymind/configuration/syncnewsletterstable', $scope['scope_id'], $scope['scope']);

        // Get fields for selected table
        if($table && $table != '') {
            // Get tables from database
            $read = Mage::getSingleton('core/resource')->getConnection('core_read');

            $query = "SHOW COLUMNS FROM `" . $table . "`;";
            $results = $read->fetchAll($query);

            $fields = array();
            if ($results && is_array($results) && sizeof($results)) {
                foreach ($results as $row) {
                    array_push($fields, $row['Field']);
                }
            }

            $this->_tableFields = $fields;
        }

        $this->_shopimindFields = array(
            '' => $helper->__('Exclude field'),
            'id_shop' => $helper->__('Store ID'),
            'last_name' => $helper->__('Last name'),
            'first_name' => $helper->__('First name'),
            'email' => $helper->__('E-mail'),
            'zipcode' => $helper->__('Zip code'),
            'last_update' => $helper->__('Registration date'),
            'status' => $helper->__('Registration status'),
        );

        $this->addColumn(
            'field', array(
                'label' => $helper->__('Table field'),
                'style' => 'width:240px',
            )
        );
        $this->addColumn(
            'shopimind', array(
                'label' => $helper->__('Shopimind'),
                'style' => 'width:240px',
            )
        );

        $this->_addAfter = false;

        parent::__construct();

        $this->setTemplate('SPM/Shopymind/system/config/form/field/array_dropdown.phtml');
    }

    protected function _renderCellTemplate($columnName)
    {
        if (empty($this->_columns[$columnName])) {
            throw new Exception('Wrong column name specified.');
        }

        $column = $this->_columns[$columnName];
        $inputName = $this->getElement()->getName() . '[#{_id}][' . $columnName . ']';

        if ($columnName == 'shopimind') {
            $rendered = '<select name="' . $inputName . '">';

            foreach($this->_shopimindFields as $key => $field) {
                $rendered .= '<option value="' . $key . '">' . $field . '</option>';
            }

            $rendered .= '</select>';
        } else {
            return '<input type="hidden" name="' . $inputName . '" value="#{' . $columnName . '}" ' . ($column['size'] ? 'size="' . $column['size'] . '"' : '') . ' />#{' . $columnName . '}';
        }

        return $rendered;

    }

    /**
     * @return Mage_Core_Helper_Abstract
     */
    protected function makeHelper()
    {
        return Mage::helper('shopymind');
    }
}
