<?php

class SPM_ShopyMind_DataMapper_OrderItem
{
    public function format(Mage_Sales_Model_Order_Item $orderItem)
    {	
		$tablePrefix = Mage::getConfig()->getTablePrefix();
		$read = Mage::getSingleton('core/resource')->getConnection('core_read');
		$query = '
				SELECT 
                    type_id
                FROM
                    ' . $tablePrefix . 'catalog_product_entity
                WHERE
                    entity_id = "'.$orderItem->getProductId().'"';
		$results = $read->fetchRow($query);
		
        if ($results && is_array($results) && sizeof($results)) {
            $type = $results['type_id'];
		}
		else {
			$type = 'simple';
		}

        $queryStoreId = array(0);
		if(!is_null($orderItem->getStoreId()) && $orderItem->getStoreId() > 0){
		    array_push($queryStoreId, $orderItem->getStoreId());
        }
        $queryStoreId = implode(',', $queryStoreId);

		$query = '
				SELECT 
                    value, store_id
                FROM
                    ' . $tablePrefix . 'catalog_product_entity_int
                WHERE
                    entity_id = "'.$orderItem->getProductId().'"
					AND attribute_id = "'.Mage::helper('shopymind')->getMagentoAttributeCode('catalog_product', 'visibility').'"
					AND store_id IN ('.$queryStoreId.')
				ORDER BY store_id DESC
				LIMIT 1';
					
		$results = $read->fetchRow($query);
		
		if ($results && is_array($results) && sizeof($results)) {
            $visible = $results['value'] != 1 ? true : false;
		}
		else {
			$visible = true;
		}
		
        $combinationId = $this->getCombinationId($orderItem);
        $idProduct = $orderItem->getProductId();
		
        if($type == "simple" && !$visible){
            $parentIds = Mage::getModel('catalog/product_type_grouped')->getParentIdsByChild($idProduct);
            if(!$parentIds)
                $parentIds = Mage::getModel('catalog/product_type_configurable')->getParentIdsByChild($idProduct);
            if(isset($parentIds[0])){
                $combinationId = $idProduct;
                $idProduct = $parentIds[0];
            }
        }
        
        return array(
            'id_product' => $idProduct,
            'id_combination' => $combinationId,
            'price' => $orderItem->getPriceInclTax(),
            'price_without_tax' => $orderItem->getPrice(),
            'qty' => $orderItem->getQtyOrdered(),
        );
    }

    private function getCombinationId(Mage_Sales_Model_Order_Item $orderItem)
    {
        $Product = Mage::getModel('catalog/product');
        $combinationId = $orderItem->getHasChildren() ? $Product->getIdBySku($orderItem->getSku()) : $orderItem->getProductId();

        return $combinationId;
    }
}
