<?php

class SPM_ShopyMind_DataMapper_QuoteItem
{
    public function format(Mage_Sales_Model_Quote_Item $quoteItem)
    {
        $product = $quoteItem->getProduct();
        $combinationId = $this->getCombinationId($quoteItem);
        $idProduct = $quoteItem->getProductId();
        if($product->getTypeId() == "simple" && !$product->isVisibleInSiteVisibility()){
            $parentIds = Mage::getModel('catalog/product_type_grouped')->getParentIdsByChild($product->getId());
            if(!$parentIds)
                $parentIds = Mage::getModel('catalog/product_type_configurable')->getParentIdsByChild($product->getId());
                if(isset($parentIds[0])){
                    $combinationId = $idProduct;
                    $idProduct = $parentIds[0];
                }
        }
        return array(
            'id_product' => $idProduct,
            'id_combination' => $combinationId,
            'id_manufacturer' => Mage::helper('shopymind')->manufacturerIdOf($product),
            'price' => $quoteItem->getPriceInclTax(),
            'price_without_tax' => $quoteItem->getPrice(),
            'qty' => $quoteItem->getQty()
        );
    }

    private function getCombinationId(Mage_Sales_Model_Quote_Item $quoteItem)
    {
            $children = $quoteItem->getChildren();
            $combinationId = count($children) ? $children[0]->getProductId() : $quoteItem->getProductId();

        return $combinationId;
    }

}
