<?php
class SPM_ShopyMind_Model_System_Config_Source_Tables
{

    /**
     * List of all tables in database
     *
     * @access protected
     * @var    array Database tables
     */
    protected $_tables = null;

    /**
     * @var SPM_Shopymind_Helper_Data
     */
    protected $_helper;


    /**
     * Load tables and store on class property
     */
    public function __construct()
    {
        $this->_helper = $this->makeHelper();

        if ($this->_tables == null) {
            // Get tables from database
            $tablePrefix = Mage::getConfig()->getTablePrefix();
            $read = Mage::getSingleton('core/resource')->getConnection('core_read');

            $query = "SHOW TABLES LIKE '" . $tablePrefix . "%';";
            $results = $read->fetchAll($query);

            $tables = array();
            if ($results && is_array($results) && sizeof($results)) {
                foreach ($results as $row) {
                    array_push($tables, $row[array_keys($row)[0]]);
                }
            }

            $this->_tables = $tables;
        }
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $helper = $this->getHelper();
        $tables = array();

        if (is_array($this->_tables)) {
            $tables[] = array('value' => '', 'label' => $helper->__('--- Select a table ---'));
            foreach ($this->_tables as $table) {
                $tables[] = array('value' => $table, 'label' => $table);
            }
        } else {
            $tables[] = array('value' => '', 'label' => $helper->__('--- No table found ---'));
        }

        return $tables;
    }

    /**
     * @return SPM_Shopymind_Helper_Data
     */
    protected function getHelper()
    {
        return $this->_helper;
    }

    /**
     * @return SPM_Shopymind_Helper_Data
     */
    protected function makeHelper()
    {
        return Mage::helper('shopymind');
    }
}
