<?php

class SPM_ShopyMind_RetrievecartController extends Mage_Core_Controller_Front_Action {

    public function indexAction(){
        
        // Get params
        $params = $this->getRequest()->getParams();
        
        // First verification
        if (!isset($params['shpmid_cart_id']) || !isset($params['shpmid_cart_secret'])){
            return $this->getResponse()->setRedirect( Mage::helper('checkout/cart')->getCartUrl())->sendResponse();;
        }

        // Load quote
        $quote = Mage::getModel('sales/quote')->load($params['shpmid_cart_id']);

        // Quote does not exist
        if (!$quote->getId()){
            return $this->getResponse()->setRedirect( Mage::helper('checkout/cart')->getCartUrl())->sendResponse();;
        }
        
        // Check secret
        $token = md5($quote->getCustomerId().'-'.$quote->getId().'-'.$quote->getCreatedAt().'-'.sha1($this->_getSpmPassword()));
        if (!$token || $token != $params['shpmid_cart_secret']){
            return $this->getResponse()->setRedirect( Mage::helper('checkout/cart')->getCartUrl())->sendResponse();
        }

        // Auto log customer
        if ($quote->getCustomerId()){
            $customer = Mage::getModel('customer/customer')->load($quote->getCustomerId());
            Mage::getSingleton('customer/session')->setCustomerAsLoggedIn($customer);
        }
        else {
            // Get cart
            $cart = Mage::getSingleton('checkout/cart');
            //Resume cart
            foreach ($cart->getQuote()->getAllVisibleItems() as $item) {
                foreach ($quote->getAllItems() as $quoteItem) {
                    if ($quoteItem->compare($item)) {
                        break;
                    }else {
                        $clonedItem = clone $item;
                        $quote->addItem($clonedItem);
                        if ($quote->getHasChildren()) {
                            foreach ($item->getChildren() as $child) {
                                $newChild = clone $child;
                                $newChild->setParentItem($clonedItem);
                                $quote->addItem($newChild);
                            }
                        }
                    }
                }
            }

            $quote->save();
            $cart->setQuote($quote);
            $cart->init();
            $cart->save();
        }

        // Redirect to checkout
        return $this->getResponse()->setRedirect( Mage::helper('checkout/cart')->getCartUrl())->sendResponse();;
    }
    public function _getSpmPassword()
    {
        $SHOPYMIND_CLIENT_CONFIGURATION = array();
        try {
            $SHOPYMIND_CLIENT_CONFIGURATION = require Mage::getBaseDir('base') . '/lib/ShopymindClient/configuration.php';
        } catch (Exception $e) {
            Mage::log($e->getMessage(), Zend_Log::ERR);
        }
        return @$SHOPYMIND_CLIENT_CONFIGURATION['api']['password'];
    }
}
