<?php

if (! isset($SHOPYMIND_CLIENT_CONFIGURATION)) {
    global $SHOPYMIND_CLIENT_CONFIGURATION;
    $SHOPYMIND_CLIENT_CONFIGURATION = array_merge_recursive(require dirname(__FILE__) . '/Src/definitions.php', require dirname(__FILE__) . '/configuration.php');
}

require_once dirname(__FILE__) . '/Src/Server.php';

$server = new ShopymindClient_Src_Server();

try {
    if ($server->isValid() === true) {
        if ($server->getTypeRequest() === 'sayHello') {
            $config = $SHOPYMIND_CLIENT_CONFIGURATION;
            $server->sendResponse(array(
                'version' => $config['version'],
                'ecommerceVersion' => Mage::getVersion(),
                'moduleVersion' => $config['moduleVersion']
            ));
        }  else if ($server->getTypeRequest() === 'setScriptUrl') {
            if (method_exists('ShopymindClient_Callback', 'setScriptUrl')) {
                $params = $server->retrieveParams();
                ShopymindClient_Callback::setScriptUrl((isset($params['script_url']) ? $params['script_url'] : ''));
            }
            $server->sendResponse(array(
                'success' => true,
            ), true);
        } elseif ($server->getTypeRequest() === 'dailyUpdate') {
            require_once dirname(__FILE__) . '/Callback.php';
            $response = array();
            $params = $server->retrieveParams();
            if (method_exists('ShopymindClient_Callback', 'deleteUnusedVouchers')) {
                $response['deleteUnusedVouchers'] = ShopymindClient_Callback::deleteUnusedVouchers();
            }
            $server->sendResponse($response, true);
        } elseif ($server->getTypeRequest() === 'getTestData') {
            require_once dirname(__FILE__) . '/Callback.php';
            $response = array();
            $params = $server->retrieveParams();
            if (method_exists('ShopymindClient_Callback', 'getTestData')) {
                $server->sendResponse(array(
                    'testData' => ShopymindClient_Callback::getTestData((isset($params['shopIdShop']) ? $params['shopIdShop'] : false), (isset($params['lang']) ? $params['lang'] : false))
                ), true);
            }
            $server->sendResponse($response, true);
        } elseif ($server->getTypeRequest() === 'generateVouchers') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'generateVouchers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'vouchers' => ShopymindClient_Callback::generateVouchers(
                        $params['voucherInfos'],
                        $params['voucherEmails'],
                        (isset($params['shopIdShop']) ? $params['shopIdShop'] : false),
                        (isset($params['voucherInfos']['dynamicPrefix']) ? $params['voucherInfos']['dynamicPrefix'] : false),
                        (isset($params['voucherInfos']['duplicateCode']) ? $params['voucherInfos']['duplicateCode'] : false),
                        (isset($params['voucherInfos']['codeToGenerate']) ? $params['voucherInfos']['codeToGenerate'] : false)
                )
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'getCountries') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getCountries')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'countries' => ShopymindClient_Callback::getCountries()
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'getCurrencies') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getCurrencies')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'currencies' => ShopymindClient_Callback::getCurrencies()
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'getLangs') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getLangs')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'langs' => ShopymindClient_Callback::getLangs((isset($params['shopIdShop']) ? $params['shopIdShop'] : false))
                ), true);
            }
        }
        /**
         *  SYNC REQUESTS   ------------
         */
        elseif ($server->getTypeRequest() === 'syncCustomers') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncCustomers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'customers' => ShopymindClient_Callback::syncCustomers((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idCustomer']) ? $params['idCustomer'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }elseif ($server->getTypeRequest() === 'syncCustomersGroups') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncCustomersGroups')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'customersGroups' => ShopymindClient_Callback::syncCustomersGroups((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idGroup']) ? $params['idGroup'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }
        //Start
        elseif ($server->getTypeRequest() === 'syncManufacturers') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncManufacturers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'manufacturers' => ShopymindClient_Callback::syncManufacturers((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idManufacturer']) ? $params['idManufacturer'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }elseif ($server->getTypeRequest() === 'syncCarriers') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncCarriers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'carriers' => ShopymindClient_Callback::syncCarriers((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idCarrier']) ? $params['idCarrier'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }elseif ($server->getTypeRequest() === 'syncOrdersStatus') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncOrdersStatus')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'ordersStatus' => ShopymindClient_Callback::syncOrdersStatus((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idStatus']) ? $params['idStatus'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }elseif ($server->getTypeRequest() === 'syncVouchers') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncVouchers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'vouchers' => ShopymindClient_Callback::syncVouchers((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idVoucher']) ? $params['idVoucher'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        }
        //End
        elseif ($server->getTypeRequest() === 'syncProducts') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncProducts')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'products' => ShopymindClient_Callback::syncProducts((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idProduct']) ? $params['idProduct'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'syncProductsCategories') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncProductsCategories')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'productsCategories' => ShopymindClient_Callback::syncProductsCategories((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idCategory']) ? $params['idCategory'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'syncOrders') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncOrders')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
                    'orders' => ShopymindClient_Callback::syncOrders((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['idOrder']) ? $params['idOrder'] : false),(isset($params['justCount']) ? $params['justCount'] : false))
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'createCustomer') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'createCustomer')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'success' => ShopymindClient_Callback::createCustomer((isset($params['shopIdShop']) ? $params['shopIdShop'] : false), $params['customer'])
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'unsubCustomer') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'unsubCustomer')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'success' => ShopymindClient_Callback::unsubCustomer((isset($params['shopIdShop']) ? $params['shopIdShop'] : false), $params['id_customer'], $params['email'])
                ), true);
            }
        } elseif ($server->getTypeRequest() === 'syncNewsletters') {
			// Pas encore implémenté
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'syncNLSubscribers')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'lastUpdate' => date('Y-m-d H:i:s'),
					'newsletters' => ShopymindClient_Callback::syncNLSubscribers((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),(isset($params['start']) ? $params['start'] : false),(isset($params['limit']) ? $params['limit'] : false),(isset($params['lastUpdate']) ? $params['lastUpdate'] : false),(isset($params['justCount']) ? $params['justCount'] : false)),
                ), true);
            }
		}
        /**
         *  END SYNC REQUESTS   ----------
         */

        elseif ($server->getTypeRequest() === 'getUser') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getUser')) {
                $params = $server->retrieveParams();
                if(isset($params['idUser']) && $params['idUser'])
                    $server->sendResponse(array(
                        'user' => ShopymindClient_Callback::getUser($params['idUser'])
                    ), true);
            }
        } elseif ($server->getTypeRequest() === 'getCarts') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getCarts')) {
                $params = $server->retrieveParams();
                if(isset($params['idCart']) && $params['idCart'])
                    $server->sendResponse(array(
                        'carts' => ShopymindClient_Callback::getCarts((isset($params['shopIdShop']) ? $params['shopIdShop'] : false),$params['idCart'])
                    ), true);
            }
        } elseif ($server->getTypeRequest() === 'getOrder') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getOrder')) {
                $params = $server->retrieveParams();
                if(isset($params['idOrder']) && $params['idOrder'])
                    $server->sendResponse(array(
                        'order' => ShopymindClient_Callback::getOrder($params['idOrder'])
                    ), true);
            }
        } elseif ($server->getTypeRequest() === 'getShops') {
            require_once dirname(__FILE__) . '/Callback.php';
            if (method_exists('ShopymindClient_Callback', 'getShops')) {
                $params = $server->retrieveParams();
                $server->sendResponse(array(
                    'shops' => ShopymindClient_Callback::getShops()
                ), true);
            }
        }
    }
} catch (Exception $e) {
    $server->sendResponse(array(
        'success' => false,
        'message' => $e->getMessage(),
        'stacktrace' => $e->getTrace(),
    ));
}

$server->sendResponse(array(), false);
